from aerforge import *

class Gravity:
    def __init__(self, object, gravity = 0.1):
        self.object = object

        self.objects = []

        self.state = False
        self.grounded = False
        self.velocity = 0

        self.gravity = gravity

    def force(self, force):
        self.velocity = self.velocity + force

    def update(self):
        self.object.y = self.object.y + int(self.velocity)

        self.object.update()

        self.state = False

        for i in self.objects:
            if not i._destroyed:
                if self.object.hit(i):
                    self.object.y = i.y - self.object.height + 1
                    self.velocity = 0
                    self.grounded = True
                    self.state = True

        if not self.state:
            self.grounded = False

        self.state = False

        if not self.grounded:
            self.velocity = self.velocity + self.gravity

if __name__ == "__main__":
    forge = Forge()

    cube = GameObject(window = forge, width = 50, height = 50, color = Color(50, 50, 100))
    cube.center()

    ground = GameObject(window = forge, width = 1200, height = 50, color = Color(100, 100, 100))
    ground.y = 550

    gravity = Gravity(cube)
    gravity.objects.append(ground)

    while True:
        gravity.update()
        cube.update()
        ground.update()
        forge.update()