from aerforgesdl import *

class TopViewController:
    def __init__(self, window, x = 0, y = 0, width = 50, height = 100, color = Color(240, 240, 240)):
        self.player = GameObject(window = window,  width = width, height = height, x = x,  y = y, color = color)

        self.window = window

        self.speed = 0
        self.sprint_speed = 2
        self.walk_speed = 1

    def update(self):
        if self.window.input.key_pressed(self.window.keys["LSHIFT"]):
            self.speed = self.sprint_speed
        else:
            self.speed = self.walk_speed

        if self.window.input.key_pressed(self.window.keys["W"]):
            self.player.y = self.player.y - self.speed

        if self.window.input.key_pressed(self.window.keys["S"]):
            self.player.y = self.player.y + self.speed

        if self.window.input.key_pressed(self.window.keys["A"]):
            self.player.x = self.player.x - self.speed

        if self.window.input.key_pressed(self.window.keys["D"]):
            self.player.x = self.player.x + self.speed

        self.player.update()

if __name__ == "__main__":
    forge = Forge()

    player = TopViewController(window = forge, color = Color(200, 120, 0))

    while True:
        player.update()
        forge.update()